from abjad.tools.pitchtools import NamedChromaticPitchClass


lilypond_version = "2.15.23"

language_pitch_names = {
    'nederlands':  {
        'ceses': NamedChromaticPitchClass('cff'),
        'ceh': NamedChromaticPitchClass('cqf'),
        'ces': NamedChromaticPitchClass('cf'),
        'ceseh': NamedChromaticPitchClass('ctqf'),
        'c': NamedChromaticPitchClass('c'),
        'cis': NamedChromaticPitchClass('cs'),
        'cih': NamedChromaticPitchClass('cqs'),
        'cisih': NamedChromaticPitchClass('ctqs'),
        'cisis': NamedChromaticPitchClass('css'),
        'deses': NamedChromaticPitchClass('dff'),
        'deh': NamedChromaticPitchClass('dqf'),
        'des': NamedChromaticPitchClass('df'),
        'deseh': NamedChromaticPitchClass('dtqf'),
        'd': NamedChromaticPitchClass('d'),
        'dis': NamedChromaticPitchClass('ds'),
        'dih': NamedChromaticPitchClass('dqs'),
        'disih': NamedChromaticPitchClass('dtqs'),
        'disis': NamedChromaticPitchClass('dss'),
        'eeses': NamedChromaticPitchClass('eff'),
        'eses': NamedChromaticPitchClass('eff'),
        'eeh': NamedChromaticPitchClass('eqf'),
        'ees': NamedChromaticPitchClass('ef'),
        'eeseh': NamedChromaticPitchClass('etqf'),
        'es': NamedChromaticPitchClass('ef'),
        'e': NamedChromaticPitchClass('e'),
        'eis': NamedChromaticPitchClass('es'),
        'eih': NamedChromaticPitchClass('eqs'),
        'eisih': NamedChromaticPitchClass('etqs'),
        'eisis': NamedChromaticPitchClass('ess'),
        'feses': NamedChromaticPitchClass('fff'),
        'feh': NamedChromaticPitchClass('fqf'),
        'fes': NamedChromaticPitchClass('ff'),
        'feseh': NamedChromaticPitchClass('ftqf'),
        'f': NamedChromaticPitchClass('f'),
        'fis': NamedChromaticPitchClass('fs'),
        'fih': NamedChromaticPitchClass('fqs'),
        'fisih': NamedChromaticPitchClass('ftqs'),
        'fisis': NamedChromaticPitchClass('fss'),
        'geses': NamedChromaticPitchClass('gff'),
        'geh': NamedChromaticPitchClass('gqf'),
        'ges': NamedChromaticPitchClass('gf'),
        'geseh': NamedChromaticPitchClass('gtqf'),
        'g': NamedChromaticPitchClass('g'),
        'gis': NamedChromaticPitchClass('gs'),
        'gih': NamedChromaticPitchClass('gqs'),
        'gisih': NamedChromaticPitchClass('gtqs'),
        'gisis': NamedChromaticPitchClass('gss'),
        'aeses': NamedChromaticPitchClass('aff'),
        'ases': NamedChromaticPitchClass('aff'),
        'aeh': NamedChromaticPitchClass('aqf'),
        'aes': NamedChromaticPitchClass('af'),
        'aeseh': NamedChromaticPitchClass('atqf'),
        'as': NamedChromaticPitchClass('af'),
        'a': NamedChromaticPitchClass('a'),
        'ais': NamedChromaticPitchClass('as'),
        'aih': NamedChromaticPitchClass('aqs'),
        'aisih': NamedChromaticPitchClass('atqs'),
        'aisis': NamedChromaticPitchClass('ass'),
        'beses': NamedChromaticPitchClass('bff'),
        'beh': NamedChromaticPitchClass('bqf'),
        'bes': NamedChromaticPitchClass('bf'),
        'beseh': NamedChromaticPitchClass('btqf'),
        'b': NamedChromaticPitchClass('b'),
        'bis': NamedChromaticPitchClass('bs'),
        'bih': NamedChromaticPitchClass('bqs'),
        'bisih': NamedChromaticPitchClass('btqs'),
        'bisis': NamedChromaticPitchClass('bss'),
    },

    'catalan':  {
        'dobb': NamedChromaticPitchClass('cff'),
        'dob': NamedChromaticPitchClass('cf'),
        'do': NamedChromaticPitchClass('c'),
        'dod': NamedChromaticPitchClass('cs'),
        'dodd': NamedChromaticPitchClass('css'),
        'rebb': NamedChromaticPitchClass('dff'),
        'reb': NamedChromaticPitchClass('df'),
        're': NamedChromaticPitchClass('d'),
        'red': NamedChromaticPitchClass('ds'),
        'redd': NamedChromaticPitchClass('dss'),
        'mibb': NamedChromaticPitchClass('eff'),
        'mib': NamedChromaticPitchClass('ef'),
        'mi': NamedChromaticPitchClass('e'),
        'mid': NamedChromaticPitchClass('es'),
        'midd': NamedChromaticPitchClass('ess'),
        'fabb': NamedChromaticPitchClass('fff'),
        'fab': NamedChromaticPitchClass('ff'),
        'fa': NamedChromaticPitchClass('f'),
        'fad': NamedChromaticPitchClass('fs'),
        'fadd': NamedChromaticPitchClass('fss'),
        'solbb': NamedChromaticPitchClass('gff'),
        'solb': NamedChromaticPitchClass('gf'),
        'sol': NamedChromaticPitchClass('g'),
        'sold': NamedChromaticPitchClass('gs'),
        'soldd': NamedChromaticPitchClass('gss'),
        'labb': NamedChromaticPitchClass('aff'),
        'lab': NamedChromaticPitchClass('af'),
        'la': NamedChromaticPitchClass('a'),
        'lad': NamedChromaticPitchClass('as'),
        'ladd': NamedChromaticPitchClass('ass'),
        'sibb': NamedChromaticPitchClass('bff'),
        'sib': NamedChromaticPitchClass('bf'),
        'si': NamedChromaticPitchClass('b'),
        'sid': NamedChromaticPitchClass('bs'),
        'sidd': NamedChromaticPitchClass('bss'),
        'dos': NamedChromaticPitchClass('cs'),
        'doss': NamedChromaticPitchClass('css'),
        'res': NamedChromaticPitchClass('ds'),
        'ress': NamedChromaticPitchClass('dss'),
        'mis': NamedChromaticPitchClass('es'),
        'miss': NamedChromaticPitchClass('ess'),
        'fas': NamedChromaticPitchClass('fs'),
        'fass': NamedChromaticPitchClass('fss'),
        'sols': NamedChromaticPitchClass('gs'),
        'solss': NamedChromaticPitchClass('gss'),
        'las': NamedChromaticPitchClass('as'),
        'lass': NamedChromaticPitchClass('ass'),
        'sis': NamedChromaticPitchClass('bs'),
        'siss': NamedChromaticPitchClass('bss'),
    },

    'deutsch':  {
        'ceses': NamedChromaticPitchClass('cff'),
        'ceseh': NamedChromaticPitchClass('ctqf'),
        'ces': NamedChromaticPitchClass('cf'),
        'ceh': NamedChromaticPitchClass('cqf'),
        'c': NamedChromaticPitchClass('c'),
        'cih': NamedChromaticPitchClass('cqs'),
        'cis': NamedChromaticPitchClass('cs'),
        'cisih': NamedChromaticPitchClass('ctqs'),
        'cisis': NamedChromaticPitchClass('css'),
        'deses': NamedChromaticPitchClass('dff'),
        'deseh': NamedChromaticPitchClass('dtqf'),
        'des': NamedChromaticPitchClass('df'),
        'deh': NamedChromaticPitchClass('dqf'),
        'd': NamedChromaticPitchClass('d'),
        'dih': NamedChromaticPitchClass('dqs'),
        'dis': NamedChromaticPitchClass('ds'),
        'disih': NamedChromaticPitchClass('dtqs'),
        'disis': NamedChromaticPitchClass('dss'),
        'eses': NamedChromaticPitchClass('eff'),
        'eseh': NamedChromaticPitchClass('etqf'),
        'es': NamedChromaticPitchClass('ef'),
        'eeh': NamedChromaticPitchClass('eqf'),
        'e': NamedChromaticPitchClass('e'),
        'eih': NamedChromaticPitchClass('eqs'),
        'eis': NamedChromaticPitchClass('es'),
        'eisih': NamedChromaticPitchClass('etqs'),
        'eisis': NamedChromaticPitchClass('ess'),
        'feses': NamedChromaticPitchClass('fff'),
        'feseh': NamedChromaticPitchClass('ftqf'),
        'fes': NamedChromaticPitchClass('ff'),
        'feh': NamedChromaticPitchClass('fqf'),
        'f': NamedChromaticPitchClass('f'),
        'fih': NamedChromaticPitchClass('fqs'),
        'fis': NamedChromaticPitchClass('fs'),
        'fisih': NamedChromaticPitchClass('ftqs'),
        'fisis': NamedChromaticPitchClass('fss'),
        'geses': NamedChromaticPitchClass('gff'),
        'geseh': NamedChromaticPitchClass('gtqf'),
        'ges': NamedChromaticPitchClass('gf'),
        'geh': NamedChromaticPitchClass('gqf'),
        'g': NamedChromaticPitchClass('g'),
        'gih': NamedChromaticPitchClass('gqs'),
        'gis': NamedChromaticPitchClass('gs'),
        'gisih': NamedChromaticPitchClass('gtqs'),
        'gisis': NamedChromaticPitchClass('gss'),
        'asas': NamedChromaticPitchClass('aff'),
        'asah': NamedChromaticPitchClass('atqf'),
        'ases': NamedChromaticPitchClass('aff'),
        'aseh': NamedChromaticPitchClass('atqf'),
        'as': NamedChromaticPitchClass('af'),
        'aeh': NamedChromaticPitchClass('aqf'),
        'a': NamedChromaticPitchClass('a'),
        'aih': NamedChromaticPitchClass('aqs'),
        'ais': NamedChromaticPitchClass('as'),
        'aisih': NamedChromaticPitchClass('atqs'),
        'aisis': NamedChromaticPitchClass('ass'),
        'heses': NamedChromaticPitchClass('bff'),
        'heseh': NamedChromaticPitchClass('btqf'),
        'b': NamedChromaticPitchClass('bf'),
        'beh': NamedChromaticPitchClass('bqf'),
        'h': NamedChromaticPitchClass('b'),
        'hih': NamedChromaticPitchClass('bqs'),
        'his': NamedChromaticPitchClass('bs'),
        'hisih': NamedChromaticPitchClass('btqs'),
        'hisis': NamedChromaticPitchClass('bss'),
    },

    'english':  {
        'cflatflat': NamedChromaticPitchClass('cff'),
        'cflat': NamedChromaticPitchClass('cf'),
        'c': NamedChromaticPitchClass('c'),
        'csharp': NamedChromaticPitchClass('cs'),
        'csharpsharp': NamedChromaticPitchClass('css'),
        'dflatflat': NamedChromaticPitchClass('dff'),
        'dflat': NamedChromaticPitchClass('df'),
        'd': NamedChromaticPitchClass('d'),
        'dsharp': NamedChromaticPitchClass('ds'),
        'dsharpsharp': NamedChromaticPitchClass('dss'),
        'eflatflat': NamedChromaticPitchClass('eff'),
        'eflat': NamedChromaticPitchClass('ef'),
        'e': NamedChromaticPitchClass('e'),
        'esharp': NamedChromaticPitchClass('es'),
        'esharpsharp': NamedChromaticPitchClass('ess'),
        'fflatflat': NamedChromaticPitchClass('fff'),
        'fflat': NamedChromaticPitchClass('ff'),
        'f': NamedChromaticPitchClass('f'),
        'fsharp': NamedChromaticPitchClass('fs'),
        'fsharpsharp': NamedChromaticPitchClass('fss'),
        'gflatflat': NamedChromaticPitchClass('gff'),
        'gflat': NamedChromaticPitchClass('gf'),
        'g': NamedChromaticPitchClass('g'),
        'gsharp': NamedChromaticPitchClass('gs'),
        'gsharpsharp': NamedChromaticPitchClass('gss'),
        'aflatflat': NamedChromaticPitchClass('aff'),
        'aflat': NamedChromaticPitchClass('af'),
        'a': NamedChromaticPitchClass('a'),
        'asharp': NamedChromaticPitchClass('as'),
        'asharpsharp': NamedChromaticPitchClass('ass'),
        'bflatflat': NamedChromaticPitchClass('bff'),
        'bflat': NamedChromaticPitchClass('bf'),
        'b': NamedChromaticPitchClass('b'),
        'bsharp': NamedChromaticPitchClass('bs'),
        'bsharpsharp': NamedChromaticPitchClass('bss'),
        'cff': NamedChromaticPitchClass('cff'),
        'ctqf': NamedChromaticPitchClass('ctqf'),
        'cf': NamedChromaticPitchClass('cf'),
        'cqf': NamedChromaticPitchClass('cqf'),
        'c': NamedChromaticPitchClass('c'),
        'cqs': NamedChromaticPitchClass('cqs'),
        'cs': NamedChromaticPitchClass('cs'),
        'ctqs': NamedChromaticPitchClass('ctqs'),
        'css': NamedChromaticPitchClass('css'),
        'cx': NamedChromaticPitchClass('css'),
        'dff': NamedChromaticPitchClass('dff'),
        'dtqf': NamedChromaticPitchClass('dtqf'),
        'df': NamedChromaticPitchClass('df'),
        'dqf': NamedChromaticPitchClass('dqf'),
        'd': NamedChromaticPitchClass('d'),
        'dqs': NamedChromaticPitchClass('dqs'),
        'ds': NamedChromaticPitchClass('ds'),
        'dtqs': NamedChromaticPitchClass('dtqs'),
        'dss': NamedChromaticPitchClass('dss'),
        'dx': NamedChromaticPitchClass('dss'),
        'eff': NamedChromaticPitchClass('eff'),
        'etqf': NamedChromaticPitchClass('etqf'),
        'ef': NamedChromaticPitchClass('ef'),
        'eqf': NamedChromaticPitchClass('eqf'),
        'e': NamedChromaticPitchClass('e'),
        'eqs': NamedChromaticPitchClass('eqs'),
        'es': NamedChromaticPitchClass('es'),
        'etqs': NamedChromaticPitchClass('etqs'),
        'ess': NamedChromaticPitchClass('ess'),
        'ex': NamedChromaticPitchClass('ess'),
        'fff': NamedChromaticPitchClass('fff'),
        'ftqf': NamedChromaticPitchClass('ftqf'),
        'ff': NamedChromaticPitchClass('ff'),
        'fqf': NamedChromaticPitchClass('fqf'),
        'f': NamedChromaticPitchClass('f'),
        'fqs': NamedChromaticPitchClass('fqs'),
        'fs': NamedChromaticPitchClass('fs'),
        'ftqs': NamedChromaticPitchClass('ftqs'),
        'fss': NamedChromaticPitchClass('fss'),
        'fx': NamedChromaticPitchClass('fss'),
        'gff': NamedChromaticPitchClass('gff'),
        'gtqf': NamedChromaticPitchClass('gtqf'),
        'gf': NamedChromaticPitchClass('gf'),
        'gqf': NamedChromaticPitchClass('gqf'),
        'g': NamedChromaticPitchClass('g'),
        'gqs': NamedChromaticPitchClass('gqs'),
        'gs': NamedChromaticPitchClass('gs'),
        'gtqs': NamedChromaticPitchClass('gtqs'),
        'gss': NamedChromaticPitchClass('gss'),
        'gx': NamedChromaticPitchClass('gss'),
        'aff': NamedChromaticPitchClass('aff'),
        'atqf': NamedChromaticPitchClass('atqf'),
        'af': NamedChromaticPitchClass('af'),
        'aqf': NamedChromaticPitchClass('aqf'),
        'a': NamedChromaticPitchClass('a'),
        'aqs': NamedChromaticPitchClass('aqs'),
        'as': NamedChromaticPitchClass('as'),
        'atqs': NamedChromaticPitchClass('atqs'),
        'ass': NamedChromaticPitchClass('ass'),
        'ax': NamedChromaticPitchClass('ass'),
        'bff': NamedChromaticPitchClass('bff'),
        'btqf': NamedChromaticPitchClass('btqf'),
        'bf': NamedChromaticPitchClass('bf'),
        'bqf': NamedChromaticPitchClass('bqf'),
        'b': NamedChromaticPitchClass('b'),
        'bqs': NamedChromaticPitchClass('bqs'),
        'bs': NamedChromaticPitchClass('bs'),
        'btqs': NamedChromaticPitchClass('btqs'),
        'bss': NamedChromaticPitchClass('bss'),
        'bx': NamedChromaticPitchClass('bss'),
    },

    'espanol':  {
        'dobb': NamedChromaticPitchClass('cff'),
        'dotcb': NamedChromaticPitchClass('ctqf'),
        'dob': NamedChromaticPitchClass('cf'),
        'docb': NamedChromaticPitchClass('cqf'),
        'do': NamedChromaticPitchClass('c'),
        'docs': NamedChromaticPitchClass('cqs'),
        'dos': NamedChromaticPitchClass('cs'),
        'dotcs': NamedChromaticPitchClass('ctqs'),
        'doss': NamedChromaticPitchClass('css'),
        'dox': NamedChromaticPitchClass('css'),
        'rebb': NamedChromaticPitchClass('dff'),
        'retcb': NamedChromaticPitchClass('dtqf'),
        'reb': NamedChromaticPitchClass('df'),
        'recb': NamedChromaticPitchClass('dqf'),
        're': NamedChromaticPitchClass('d'),
        'recs': NamedChromaticPitchClass('dqs'),
        'res': NamedChromaticPitchClass('ds'),
        'retcs': NamedChromaticPitchClass('dtqs'),
        'ress': NamedChromaticPitchClass('dss'),
        'rex': NamedChromaticPitchClass('dss'),
        'mibb': NamedChromaticPitchClass('eff'),
        'mitcb': NamedChromaticPitchClass('etqf'),
        'mib': NamedChromaticPitchClass('ef'),
        'micb': NamedChromaticPitchClass('eqf'),
        'mi': NamedChromaticPitchClass('e'),
        'mics': NamedChromaticPitchClass('eqs'),
        'mis': NamedChromaticPitchClass('es'),
        'mitcs': NamedChromaticPitchClass('etqs'),
        'miss': NamedChromaticPitchClass('ess'),
        'mix': NamedChromaticPitchClass('ess'),
        'fabb': NamedChromaticPitchClass('fff'),
        'fatcb': NamedChromaticPitchClass('ftqf'),
        'fab': NamedChromaticPitchClass('ff'),
        'facb': NamedChromaticPitchClass('fqf'),
        'fa': NamedChromaticPitchClass('f'),
        'facs': NamedChromaticPitchClass('fqs'),
        'fas': NamedChromaticPitchClass('fs'),
        'fatcs': NamedChromaticPitchClass('ftqs'),
        'fass': NamedChromaticPitchClass('fss'),
        'fax': NamedChromaticPitchClass('fss'),
        'solbb': NamedChromaticPitchClass('gff'),
        'soltcb': NamedChromaticPitchClass('gtqf'),
        'solb': NamedChromaticPitchClass('gf'),
        'solcb': NamedChromaticPitchClass('gqf'),
        'sol': NamedChromaticPitchClass('g'),
        'solcs': NamedChromaticPitchClass('gqs'),
        'sols': NamedChromaticPitchClass('gs'),
        'soltcs': NamedChromaticPitchClass('gtqs'),
        'solss': NamedChromaticPitchClass('gss'),
        'solx': NamedChromaticPitchClass('gss'),
        'labb': NamedChromaticPitchClass('aff'),
        'latcb': NamedChromaticPitchClass('atqf'),
        'lab': NamedChromaticPitchClass('af'),
        'lacb': NamedChromaticPitchClass('aqf'),
        'la': NamedChromaticPitchClass('a'),
        'lacs': NamedChromaticPitchClass('aqs'),
        'las': NamedChromaticPitchClass('as'),
        'latcs': NamedChromaticPitchClass('atqs'),
        'lass': NamedChromaticPitchClass('ass'),
        'lax': NamedChromaticPitchClass('ass'),
        'sibb': NamedChromaticPitchClass('bff'),
        'sitcb': NamedChromaticPitchClass('btqf'),
        'sib': NamedChromaticPitchClass('bf'),
        'sicb': NamedChromaticPitchClass('bqf'),
        'si': NamedChromaticPitchClass('b'),
        'sics': NamedChromaticPitchClass('bqs'),
        'sis': NamedChromaticPitchClass('bs'),
        'sitcs': NamedChromaticPitchClass('btqs'),
        'siss': NamedChromaticPitchClass('bss'),
        'six': NamedChromaticPitchClass('bss'),
    },

    'italiano':  {
        'dobb': NamedChromaticPitchClass('cff'),
        'dobsb': NamedChromaticPitchClass('ctqf'),
        'dob': NamedChromaticPitchClass('cf'),
        'dosb': NamedChromaticPitchClass('cqf'),
        'do': NamedChromaticPitchClass('c'),
        'dosd': NamedChromaticPitchClass('cqs'),
        'dod': NamedChromaticPitchClass('cs'),
        'dodsd': NamedChromaticPitchClass('ctqs'),
        'dodd': NamedChromaticPitchClass('css'),
        'rebb': NamedChromaticPitchClass('dff'),
        'rebsb': NamedChromaticPitchClass('dtqf'),
        'reb': NamedChromaticPitchClass('df'),
        'resb': NamedChromaticPitchClass('dqf'),
        're': NamedChromaticPitchClass('d'),
        'resd': NamedChromaticPitchClass('dqs'),
        'red': NamedChromaticPitchClass('ds'),
        'redsd': NamedChromaticPitchClass('dtqs'),
        'redd': NamedChromaticPitchClass('dss'),
        'mibb': NamedChromaticPitchClass('eff'),
        'mibsb': NamedChromaticPitchClass('etqf'),
        'mib': NamedChromaticPitchClass('ef'),
        'misb': NamedChromaticPitchClass('eqf'),
        'mi': NamedChromaticPitchClass('e'),
        'misd': NamedChromaticPitchClass('eqs'),
        'mid': NamedChromaticPitchClass('es'),
        'midsd': NamedChromaticPitchClass('etqs'),
        'midd': NamedChromaticPitchClass('ess'),
        'fabb': NamedChromaticPitchClass('fff'),
        'fabsb': NamedChromaticPitchClass('ftqf'),
        'fab': NamedChromaticPitchClass('ff'),
        'fasb': NamedChromaticPitchClass('fqf'),
        'fa': NamedChromaticPitchClass('f'),
        'fasd': NamedChromaticPitchClass('fqs'),
        'fad': NamedChromaticPitchClass('fs'),
        'fadsd': NamedChromaticPitchClass('ftqs'),
        'fadd': NamedChromaticPitchClass('fss'),
        'solbb': NamedChromaticPitchClass('gff'),
        'solbsb': NamedChromaticPitchClass('gtqf'),
        'solb': NamedChromaticPitchClass('gf'),
        'solsb': NamedChromaticPitchClass('gqf'),
        'sol': NamedChromaticPitchClass('g'),
        'solsd': NamedChromaticPitchClass('gqs'),
        'sold': NamedChromaticPitchClass('gs'),
        'soldsd': NamedChromaticPitchClass('gtqs'),
        'soldd': NamedChromaticPitchClass('gss'),
        'labb': NamedChromaticPitchClass('aff'),
        'labsb': NamedChromaticPitchClass('atqf'),
        'lab': NamedChromaticPitchClass('af'),
        'lasb': NamedChromaticPitchClass('aqf'),
        'la': NamedChromaticPitchClass('a'),
        'lasd': NamedChromaticPitchClass('aqs'),
        'lad': NamedChromaticPitchClass('as'),
        'ladsd': NamedChromaticPitchClass('atqs'),
        'ladd': NamedChromaticPitchClass('ass'),
        'sibb': NamedChromaticPitchClass('bff'),
        'sibsb': NamedChromaticPitchClass('btqf'),
        'sib': NamedChromaticPitchClass('bf'),
        'sisb': NamedChromaticPitchClass('bqf'),
        'si': NamedChromaticPitchClass('b'),
        'sisd': NamedChromaticPitchClass('bqs'),
        'sid': NamedChromaticPitchClass('bs'),
        'sidsd': NamedChromaticPitchClass('btqs'),
        'sidd': NamedChromaticPitchClass('bss'),
    },

    'norsk':  {
        'ceses': NamedChromaticPitchClass('cff'),
        'cessess': NamedChromaticPitchClass('cff'),
        'ces': NamedChromaticPitchClass('cf'),
        'cess': NamedChromaticPitchClass('cf'),
        'c': NamedChromaticPitchClass('c'),
        'cis': NamedChromaticPitchClass('cs'),
        'ciss': NamedChromaticPitchClass('cs'),
        'cisis': NamedChromaticPitchClass('css'),
        'cississ': NamedChromaticPitchClass('css'),
        'deses': NamedChromaticPitchClass('dff'),
        'dessess': NamedChromaticPitchClass('dff'),
        'des': NamedChromaticPitchClass('df'),
        'dess': NamedChromaticPitchClass('df'),
        'd': NamedChromaticPitchClass('d'),
        'dis': NamedChromaticPitchClass('ds'),
        'diss': NamedChromaticPitchClass('ds'),
        'disis': NamedChromaticPitchClass('dss'),
        'dississ': NamedChromaticPitchClass('dss'),
        'eeses': NamedChromaticPitchClass('eff'),
        'eessess': NamedChromaticPitchClass('eff'),
        'eses': NamedChromaticPitchClass('eff'),
        'essess': NamedChromaticPitchClass('eff'),
        'ees': NamedChromaticPitchClass('ef'),
        'eess': NamedChromaticPitchClass('ef'),
        'es': NamedChromaticPitchClass('ef'),
        'ess': NamedChromaticPitchClass('ef'),
        'e': NamedChromaticPitchClass('e'),
        'eis': NamedChromaticPitchClass('es'),
        'eiss': NamedChromaticPitchClass('es'),
        'eisis': NamedChromaticPitchClass('ess'),
        'eississ': NamedChromaticPitchClass('ess'),
        'feses': NamedChromaticPitchClass('fff'),
        'fessess': NamedChromaticPitchClass('fff'),
        'fes': NamedChromaticPitchClass('ff'),
        'fess': NamedChromaticPitchClass('ff'),
        'f': NamedChromaticPitchClass('f'),
        'fis': NamedChromaticPitchClass('fs'),
        'fiss': NamedChromaticPitchClass('fs'),
        'fisis': NamedChromaticPitchClass('fss'),
        'fississ': NamedChromaticPitchClass('fss'),
        'geses': NamedChromaticPitchClass('gff'),
        'gessess': NamedChromaticPitchClass('gff'),
        'ges': NamedChromaticPitchClass('gf'),
        'gess': NamedChromaticPitchClass('gf'),
        'g': NamedChromaticPitchClass('g'),
        'g': NamedChromaticPitchClass('g'),
        'gis': NamedChromaticPitchClass('gs'),
        'giss': NamedChromaticPitchClass('gs'),
        'gisis': NamedChromaticPitchClass('gss'),
        'gississ': NamedChromaticPitchClass('gss'),
        'aeses': NamedChromaticPitchClass('aff'),
        'aessess': NamedChromaticPitchClass('aff'),
        'ases': NamedChromaticPitchClass('aff'),
        'assess': NamedChromaticPitchClass('aff'),
        'aes': NamedChromaticPitchClass('af'),
        'aess': NamedChromaticPitchClass('af'),
        'as': NamedChromaticPitchClass('af'),
        'ass': NamedChromaticPitchClass('af'),
        'a': NamedChromaticPitchClass('a'),
        'ais': NamedChromaticPitchClass('as'),
        'aiss': NamedChromaticPitchClass('as'),
        'aisis': NamedChromaticPitchClass('ass'),
        'aississ': NamedChromaticPitchClass('ass'),
        'bes': NamedChromaticPitchClass('bff'),
        'bess': NamedChromaticPitchClass('bff'),
        'b': NamedChromaticPitchClass('bf'),
        'b': NamedChromaticPitchClass('bf'),
        'h': NamedChromaticPitchClass('b'),
        'his': NamedChromaticPitchClass('bs'),
        'hiss': NamedChromaticPitchClass('bs'),
        'hisis': NamedChromaticPitchClass('bss'),
        'hississ': NamedChromaticPitchClass('bss'),
    },

    'portugues':  {
        'dobb': NamedChromaticPitchClass('cff'),
        'dobtqt': NamedChromaticPitchClass('ctqf'),
        'dob': NamedChromaticPitchClass('cf'),
        'dobqt': NamedChromaticPitchClass('cqf'),
        'do': NamedChromaticPitchClass('c'),
        'dosqt': NamedChromaticPitchClass('cqs'),
        'dos': NamedChromaticPitchClass('cs'),
        'dostqt': NamedChromaticPitchClass('ctqs'),
        'doss': NamedChromaticPitchClass('css'),
        'rebb': NamedChromaticPitchClass('dff'),
        'rebtqt': NamedChromaticPitchClass('dtqf'),
        'reb': NamedChromaticPitchClass('df'),
        'rebqt': NamedChromaticPitchClass('dqf'),
        're': NamedChromaticPitchClass('d'),
        'resqt': NamedChromaticPitchClass('dqs'),
        'res': NamedChromaticPitchClass('ds'),
        'restqt': NamedChromaticPitchClass('dtqs'),
        'ress': NamedChromaticPitchClass('dss'),
        'mibb': NamedChromaticPitchClass('eff'),
        'mibtqt': NamedChromaticPitchClass('etqf'),
        'mib': NamedChromaticPitchClass('ef'),
        'mibqt': NamedChromaticPitchClass('eqf'),
        'mi': NamedChromaticPitchClass('e'),
        'misqt': NamedChromaticPitchClass('eqs'),
        'mis': NamedChromaticPitchClass('es'),
        'mistqt': NamedChromaticPitchClass('etqs'),
        'miss': NamedChromaticPitchClass('ess'),
        'fabb': NamedChromaticPitchClass('fff'),
        'fabtqt': NamedChromaticPitchClass('ftqf'),
        'fab': NamedChromaticPitchClass('ff'),
        'fabqt': NamedChromaticPitchClass('fqf'),
        'fa': NamedChromaticPitchClass('f'),
        'fasqt': NamedChromaticPitchClass('fqs'),
        'fas': NamedChromaticPitchClass('fs'),
        'fastqt': NamedChromaticPitchClass('ftqs'),
        'fass': NamedChromaticPitchClass('fss'),
        'solbb': NamedChromaticPitchClass('gff'),
        'solbtqt': NamedChromaticPitchClass('gtqf'),
        'solb': NamedChromaticPitchClass('gf'),
        'solbqt': NamedChromaticPitchClass('gqf'),
        'sol': NamedChromaticPitchClass('g'),
        'solsqt': NamedChromaticPitchClass('gqs'),
        'sols': NamedChromaticPitchClass('gs'),
        'solstqt': NamedChromaticPitchClass('gtqs'),
        'solss': NamedChromaticPitchClass('gss'),
        'labb': NamedChromaticPitchClass('aff'),
        'labtqt': NamedChromaticPitchClass('atqf'),
        'lab': NamedChromaticPitchClass('af'),
        'labqt': NamedChromaticPitchClass('aqf'),
        'la': NamedChromaticPitchClass('a'),
        'lasqt': NamedChromaticPitchClass('aqs'),
        'las': NamedChromaticPitchClass('as'),
        'lastqt': NamedChromaticPitchClass('atqs'),
        'lass': NamedChromaticPitchClass('ass'),
        'sibb': NamedChromaticPitchClass('bff'),
        'sibtqt': NamedChromaticPitchClass('btqf'),
        'sib': NamedChromaticPitchClass('bf'),
        'sibqt': NamedChromaticPitchClass('bqf'),
        'si': NamedChromaticPitchClass('b'),
        'sisqt': NamedChromaticPitchClass('bqs'),
        'sis': NamedChromaticPitchClass('bs'),
        'sistqt': NamedChromaticPitchClass('btqs'),
        'siss': NamedChromaticPitchClass('bss'),
    },

    'suomi':  {
        'ceses': NamedChromaticPitchClass('cff'),
        'ces': NamedChromaticPitchClass('cf'),
        'c': NamedChromaticPitchClass('c'),
        'cis': NamedChromaticPitchClass('cs'),
        'cisis': NamedChromaticPitchClass('css'),
        'deses': NamedChromaticPitchClass('dff'),
        'des': NamedChromaticPitchClass('df'),
        'd': NamedChromaticPitchClass('d'),
        'dis': NamedChromaticPitchClass('ds'),
        'disis': NamedChromaticPitchClass('dss'),
        'eses': NamedChromaticPitchClass('eff'),
        'es': NamedChromaticPitchClass('ef'),
        'e': NamedChromaticPitchClass('e'),
        'eis': NamedChromaticPitchClass('es'),
        'eisis': NamedChromaticPitchClass('ess'),
        'feses': NamedChromaticPitchClass('fff'),
        'fes': NamedChromaticPitchClass('ff'),
        'f': NamedChromaticPitchClass('f'),
        'fis': NamedChromaticPitchClass('fs'),
        'fisis': NamedChromaticPitchClass('fss'),
        'geses': NamedChromaticPitchClass('gff'),
        'ges': NamedChromaticPitchClass('gf'),
        'g': NamedChromaticPitchClass('g'),
        'gis': NamedChromaticPitchClass('gs'),
        'gisis': NamedChromaticPitchClass('gss'),
        'asas': NamedChromaticPitchClass('aff'),
        'ases': NamedChromaticPitchClass('aff'),
        'as': NamedChromaticPitchClass('af'),
        'a': NamedChromaticPitchClass('a'),
        'ais': NamedChromaticPitchClass('as'),
        'aisis': NamedChromaticPitchClass('ass'),
        'bb': NamedChromaticPitchClass('bff'),
        'bes': NamedChromaticPitchClass('bff'),
        'heses': NamedChromaticPitchClass('bff'),
        'b': NamedChromaticPitchClass('bf'),
        'h': NamedChromaticPitchClass('b'),
        'his': NamedChromaticPitchClass('bs'),
        'hisis': NamedChromaticPitchClass('bss'),
    },

    'svenska':  {
        'cessess': NamedChromaticPitchClass('cff'),
        'cess': NamedChromaticPitchClass('cf'),
        'c': NamedChromaticPitchClass('c'),
        'ciss': NamedChromaticPitchClass('cs'),
        'cississ': NamedChromaticPitchClass('css'),
        'dessess': NamedChromaticPitchClass('dff'),
        'dess': NamedChromaticPitchClass('df'),
        'd': NamedChromaticPitchClass('d'),
        'diss': NamedChromaticPitchClass('ds'),
        'dississ': NamedChromaticPitchClass('dss'),
        'essess': NamedChromaticPitchClass('eff'),
        'ess': NamedChromaticPitchClass('ef'),
        'e': NamedChromaticPitchClass('e'),
        'eiss': NamedChromaticPitchClass('es'),
        'eississ': NamedChromaticPitchClass('ess'),
        'fessess': NamedChromaticPitchClass('fff'),
        'fess': NamedChromaticPitchClass('ff'),
        'f': NamedChromaticPitchClass('f'),
        'fiss': NamedChromaticPitchClass('fs'),
        'fississ': NamedChromaticPitchClass('fss'),
        'gessess': NamedChromaticPitchClass('gff'),
        'gess': NamedChromaticPitchClass('gf'),
        'g': NamedChromaticPitchClass('g'),
        'giss': NamedChromaticPitchClass('gs'),
        'gississ': NamedChromaticPitchClass('gss'),
        'assess': NamedChromaticPitchClass('aff'),
        'ass': NamedChromaticPitchClass('af'),
        'a': NamedChromaticPitchClass('a'),
        'aiss': NamedChromaticPitchClass('as'),
        'aississ': NamedChromaticPitchClass('ass'),
        'hessess': NamedChromaticPitchClass('bff'),
        'b': NamedChromaticPitchClass('bf'),
        'h': NamedChromaticPitchClass('b'),
        'hiss': NamedChromaticPitchClass('bs'),
        'hississ': NamedChromaticPitchClass('bss'),
    },

    'vlaams':  {
        'dobb': NamedChromaticPitchClass('cff'),
        'dob': NamedChromaticPitchClass('cf'),
        'do': NamedChromaticPitchClass('c'),
        'dok': NamedChromaticPitchClass('cs'),
        'dokk': NamedChromaticPitchClass('css'),
        'rebb': NamedChromaticPitchClass('dff'),
        'reb': NamedChromaticPitchClass('df'),
        're': NamedChromaticPitchClass('d'),
        'rek': NamedChromaticPitchClass('ds'),
        'rekk': NamedChromaticPitchClass('dss'),
        'mibb': NamedChromaticPitchClass('eff'),
        'mib': NamedChromaticPitchClass('ef'),
        'mi': NamedChromaticPitchClass('e'),
        'mik': NamedChromaticPitchClass('es'),
        'mikk': NamedChromaticPitchClass('ess'),
        'fabb': NamedChromaticPitchClass('fff'),
        'fab': NamedChromaticPitchClass('ff'),
        'fa': NamedChromaticPitchClass('f'),
        'fak': NamedChromaticPitchClass('fs'),
        'fakk': NamedChromaticPitchClass('fss'),
        'solbb': NamedChromaticPitchClass('gff'),
        'solb': NamedChromaticPitchClass('gf'),
        'sol': NamedChromaticPitchClass('g'),
        'solk': NamedChromaticPitchClass('gs'),
        'solkk': NamedChromaticPitchClass('gss'),
        'labb': NamedChromaticPitchClass('aff'),
        'lab': NamedChromaticPitchClass('af'),
        'la': NamedChromaticPitchClass('a'),
        'lak': NamedChromaticPitchClass('as'),
        'lakk': NamedChromaticPitchClass('ass'),
        'sibb': NamedChromaticPitchClass('bff'),
        'sib': NamedChromaticPitchClass('bf'),
        'si': NamedChromaticPitchClass('b'),
        'sik': NamedChromaticPitchClass('bs'),
        'sikk': NamedChromaticPitchClass('bss'),
    },

}